declare filename "cubicnl_disto.dsp"; declare name "cubicnl_disto"; declare name "distortion";
declare version "0.0";
declare author "JOS, revised by RM";
declare description "Distortion demo application.";

//import("stdfaust.lib");
import("signals.lib");

zero(z) = _ <: _,mem : _,*(z) : -;

pole(p) = + ~ *(p);

dcblocker = zero(1) : pole(0.995);

cubicnl_nodc(drive,offset) = cubicnl(drive,offset) : dcblocker;

cubicnl(drive,offset) = *(pregain) : +(offset) : clip(-1,1) : cubic
with {
    pregain = pow(10.0,2*drive);
    clip(lo,hi) = min(hi) : max(lo);
    cubic(x) = x - x*x*x/3;
    postgain = max(1.0,1.0/pregain);
};

bypass1(bpc,e) = _ <: select2(bpc,(inswitch:e),_)
with {
    inswitch = select2(bpc,_,0);
};

process = bypass1(bp, cubicnl_nodc(drive,offset))
with{
	bp = checkbox("bypass");
	drive = hslider("drive", 0, 0, 10, 0.0001):si.smoo;
	offset = hslider("offset", 0, 0, 1, 0.0001):si.smoo;
};