declare filename "hyperbolic_saturator.dsp"; declare name "hyperbolic_saturator"; // hyperbolic saturator

ba = library("basics.lib");
ma = library("maths.lib");
si = library ("signals.lib");

hyperbolic(x) = x/(1+abs(x));

drive = hslider("drive", 1.0, 1., 1000.0, 0.00001):si.smoo;
gain = hslider("gain", 1.0, 1., 1000.0, 0.00001):si.smoo;

process = _ *drive : hyperbolic : _ /drive*gain;